Index: uspace/srv/net/inetsrv/inetcfg.c
===================================================================
--- uspace/srv/net/inetsrv/inetcfg.c	(revision a46e56be16ae82f0d007dd26c68b250f3f725ae0)
+++ uspace/srv/net/inetsrv/inetcfg.c	(revision 984a9ba2fa05c490a7066737655ed19130c714e8)
@@ -253,6 +253,5 @@
 }
 
-static void inetcfg_addr_create_static_srv(cap_call_handle_t icall_handle,
-    ipc_call_t *icall)
+static void inetcfg_addr_create_static_srv(ipc_call_t *icall)
 {
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "inetcfg_addr_create_static_srv()");
@@ -260,23 +259,23 @@
 	sysarg_t link_id = IPC_GET_ARG1(*icall);
 
-	cap_call_handle_t chandle;
+	ipc_call_t call;
 	size_t size;
-	if (!async_data_write_receive(&chandle, &size)) {
-		async_answer_0(chandle, EINVAL);
-		async_answer_0(icall_handle, EINVAL);
+	if (!async_data_write_receive(&call, &size)) {
+		async_answer_0(&call, EINVAL);
+		async_answer_0(icall, EINVAL);
 		return;
 	}
 
 	if (size != sizeof(inet_naddr_t)) {
-		async_answer_0(chandle, EINVAL);
-		async_answer_0(icall_handle, EINVAL);
+		async_answer_0(&call, EINVAL);
+		async_answer_0(icall, EINVAL);
 		return;
 	}
 
 	inet_naddr_t naddr;
-	errno_t rc = async_data_write_finalize(chandle, &naddr, size);
-	if (rc != EOK) {
-		async_answer_0(chandle, rc);
-		async_answer_0(icall_handle, rc);
+	errno_t rc = async_data_write_finalize(&call, &naddr, size);
+	if (rc != EOK) {
+		async_answer_0(&call, rc);
+		async_answer_0(icall, rc);
 		return;
 	}
@@ -286,5 +285,5 @@
 	    0, NULL);
 	if (rc != EOK) {
-		async_answer_0(icall_handle, rc);
+		async_answer_0(icall, rc);
 		return;
 	}
@@ -293,8 +292,8 @@
 	rc = inetcfg_addr_create_static(name, &naddr, link_id, &addr_id);
 	free(name);
-	async_answer_1(icall_handle, rc, addr_id);
-}
-
-static void inetcfg_addr_delete_srv(cap_call_handle_t chandle, ipc_call_t *call)
+	async_answer_1(icall, rc, addr_id);
+}
+
+static void inetcfg_addr_delete_srv(ipc_call_t *call)
 {
 	sysarg_t addr_id;
@@ -306,8 +305,8 @@
 
 	rc = inetcfg_addr_delete(addr_id);
-	async_answer_0(chandle, rc);
-}
-
-static void inetcfg_addr_get_srv(cap_call_handle_t icall_handle, ipc_call_t *icall)
+	async_answer_0(call, rc);
+}
+
+static void inetcfg_addr_get_srv(ipc_call_t *icall)
 {
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "inetcfg_addr_get_srv()");
@@ -323,49 +322,49 @@
 	errno_t rc = inetcfg_addr_get(addr_id, &ainfo);
 	if (rc != EOK) {
-		async_answer_0(icall_handle, rc);
-		return;
-	}
-
-	cap_call_handle_t chandle;
+		async_answer_0(icall, rc);
+		return;
+	}
+
+	ipc_call_t call;
 	size_t size;
-	if (!async_data_read_receive(&chandle, &size)) {
-		async_answer_0(chandle, EREFUSED);
-		async_answer_0(icall_handle, EREFUSED);
+	if (!async_data_read_receive(&call, &size)) {
+		async_answer_0(&call, EREFUSED);
+		async_answer_0(icall, EREFUSED);
 		return;
 	}
 
 	if (size != sizeof(inet_naddr_t)) {
-		async_answer_0(chandle, EINVAL);
-		async_answer_0(icall_handle, EINVAL);
-		return;
-	}
-
-	rc = async_data_read_finalize(chandle, &ainfo.naddr, size);
-	if (rc != EOK) {
-		async_answer_0(chandle, rc);
-		async_answer_0(icall_handle, rc);
-		return;
-	}
-
-	if (!async_data_read_receive(&chandle, &size)) {
-		async_answer_0(chandle, EREFUSED);
-		async_answer_0(icall_handle, EREFUSED);
-		return;
-	}
-
-	rc = async_data_read_finalize(chandle, ainfo.name,
+		async_answer_0(&call, EINVAL);
+		async_answer_0(icall, EINVAL);
+		return;
+	}
+
+	rc = async_data_read_finalize(&call, &ainfo.naddr, size);
+	if (rc != EOK) {
+		async_answer_0(&call, rc);
+		async_answer_0(icall, rc);
+		return;
+	}
+
+	if (!async_data_read_receive(&call, &size)) {
+		async_answer_0(&call, EREFUSED);
+		async_answer_0(icall, EREFUSED);
+		return;
+	}
+
+	rc = async_data_read_finalize(&call, ainfo.name,
 	    min(size, str_size(ainfo.name)));
 	free(ainfo.name);
 
 	if (rc != EOK) {
-		async_answer_0(chandle, rc);
-		async_answer_0(icall_handle, rc);
-		return;
-	}
-
-	async_answer_1(icall_handle, rc, ainfo.ilink);
-}
-
-static void inetcfg_addr_get_id_srv(cap_call_handle_t chandle, ipc_call_t *call)
+		async_answer_0(&call, rc);
+		async_answer_0(icall, rc);
+		return;
+	}
+
+	async_answer_1(icall, rc, ainfo.ilink);
+}
+
+static void inetcfg_addr_get_id_srv(ipc_call_t *call)
 {
 	char *name;
@@ -381,5 +380,5 @@
 	    0, NULL);
 	if (rc != EOK) {
-		async_answer_0(chandle, rc);
+		async_answer_0(call, rc);
 		return;
 	}
@@ -388,10 +387,10 @@
 	rc = inetcfg_addr_get_id(name, link_id, &addr_id);
 	free(name);
-	async_answer_1(chandle, rc, addr_id);
-}
-
-static void inetcfg_get_addr_list_srv(cap_call_handle_t chandle, ipc_call_t *call)
-{
-	cap_call_handle_t rcall_handle;
+	async_answer_1(call, rc, addr_id);
+}
+
+static void inetcfg_get_addr_list_srv(ipc_call_t *call)
+{
+	ipc_call_t rcall;
 	size_t count;
 	size_t max_size;
@@ -403,7 +402,7 @@
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "inetcfg_get_addr_list_srv()");
 
-	if (!async_data_read_receive(&rcall_handle, &max_size)) {
-		async_answer_0(rcall_handle, EREFUSED);
-		async_answer_0(chandle, EREFUSED);
+	if (!async_data_read_receive(&rcall, &max_size)) {
+		async_answer_0(&rcall, EREFUSED);
+		async_answer_0(call, EREFUSED);
 		return;
 	}
@@ -411,6 +410,6 @@
 	rc = inetcfg_get_addr_list(&id_buf, &count);
 	if (rc != EOK) {
-		async_answer_0(rcall_handle, rc);
-		async_answer_0(chandle, rc);
+		async_answer_0(&rcall, rc);
+		async_answer_0(call, rc);
 		return;
 	}
@@ -419,13 +418,13 @@
 	size = min(act_size, max_size);
 
-	errno_t retval = async_data_read_finalize(rcall_handle, id_buf, size);
+	errno_t retval = async_data_read_finalize(&rcall, id_buf, size);
 	free(id_buf);
 
-	async_answer_1(chandle, retval, act_size);
-}
-
-static void inetcfg_get_link_list_srv(cap_call_handle_t chandle, ipc_call_t *call)
-{
-	cap_call_handle_t rcall_handle;
+	async_answer_1(call, retval, act_size);
+}
+
+static void inetcfg_get_link_list_srv(ipc_call_t *call)
+{
+	ipc_call_t rcall;
 	size_t count;
 	size_t max_size;
@@ -437,7 +436,7 @@
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "inetcfg_get_addr_list_srv()");
 
-	if (!async_data_read_receive(&rcall_handle, &max_size)) {
-		async_answer_0(rcall_handle, EREFUSED);
-		async_answer_0(chandle, EREFUSED);
+	if (!async_data_read_receive(&rcall, &max_size)) {
+		async_answer_0(&rcall, EREFUSED);
+		async_answer_0(call, EREFUSED);
 		return;
 	}
@@ -445,6 +444,6 @@
 	rc = inetcfg_get_link_list(&id_buf, &count);
 	if (rc != EOK) {
-		async_answer_0(rcall_handle, rc);
-		async_answer_0(chandle, rc);
+		async_answer_0(&rcall, rc);
+		async_answer_0(call, rc);
 		return;
 	}
@@ -453,13 +452,13 @@
 	size = min(act_size, max_size);
 
-	errno_t retval = async_data_read_finalize(rcall_handle, id_buf, size);
+	errno_t retval = async_data_read_finalize(&rcall, id_buf, size);
 	free(id_buf);
 
-	async_answer_1(chandle, retval, act_size);
-}
-
-static void inetcfg_get_sroute_list_srv(cap_call_handle_t chandle, ipc_call_t *call)
-{
-	cap_call_handle_t rcall_handle;
+	async_answer_1(call, retval, act_size);
+}
+
+static void inetcfg_get_sroute_list_srv(ipc_call_t *call)
+{
+	ipc_call_t rcall;
 	size_t count;
 	size_t max_size;
@@ -471,7 +470,7 @@
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "inetcfg_get_sroute_list_srv()");
 
-	if (!async_data_read_receive(&rcall_handle, &max_size)) {
-		async_answer_0(rcall_handle, EREFUSED);
-		async_answer_0(chandle, EREFUSED);
+	if (!async_data_read_receive(&rcall, &max_size)) {
+		async_answer_0(&rcall, EREFUSED);
+		async_answer_0(call, EREFUSED);
 		return;
 	}
@@ -479,6 +478,6 @@
 	rc = inetcfg_get_sroute_list(&id_buf, &count);
 	if (rc != EOK) {
-		async_answer_0(rcall_handle, rc);
-		async_answer_0(chandle, rc);
+		async_answer_0(&rcall, rc);
+		async_answer_0(call, rc);
 		return;
 	}
@@ -487,11 +486,11 @@
 	size = min(act_size, max_size);
 
-	errno_t retval = async_data_read_finalize(rcall_handle, id_buf, size);
+	errno_t retval = async_data_read_finalize(&rcall, id_buf, size);
 	free(id_buf);
 
-	async_answer_1(chandle, retval, act_size);
-}
-
-static void inetcfg_link_add_srv(cap_call_handle_t chandle, ipc_call_t *call)
+	async_answer_1(call, retval, act_size);
+}
+
+static void inetcfg_link_add_srv(ipc_call_t *call)
 {
 	sysarg_t link_id;
@@ -503,11 +502,11 @@
 
 	rc = inetcfg_link_add(link_id);
-	async_answer_0(chandle, rc);
-}
-
-static void inetcfg_link_get_srv(cap_call_handle_t chandle, ipc_call_t *call)
-{
-	cap_call_handle_t name_chandle;
-	cap_call_handle_t laddr_chandle;
+	async_answer_0(call, rc);
+}
+
+static void inetcfg_link_get_srv(ipc_call_t *call)
+{
+	ipc_call_t name;
+	ipc_call_t laddr;
 	size_t name_max_size;
 	size_t laddr_max_size;
@@ -522,13 +521,14 @@
 	linfo.name = NULL;
 
-	if (!async_data_read_receive(&name_chandle, &name_max_size)) {
-		async_answer_0(name_chandle, EREFUSED);
-		async_answer_0(chandle, EREFUSED);
-		return;
-	}
-
-	if (!async_data_read_receive(&laddr_chandle, &laddr_max_size)) {
-		async_answer_0(name_chandle, EREFUSED);
-		async_answer_0(chandle, EREFUSED);
+	if (!async_data_read_receive(&name, &name_max_size)) {
+		async_answer_0(&name, EREFUSED);
+		async_answer_0(call, EREFUSED);
+		return;
+	}
+
+	if (!async_data_read_receive(&laddr, &laddr_max_size)) {
+		async_answer_0(&laddr, EREFUSED);
+		async_answer_0(&name, EREFUSED);
+		async_answer_0(call, EREFUSED);
 		return;
 	}
@@ -536,28 +536,28 @@
 	rc = inetcfg_link_get(link_id, &linfo);
 	if (rc != EOK) {
-		async_answer_0(laddr_chandle, rc);
-		async_answer_0(name_chandle, rc);
-		async_answer_0(chandle, rc);
-		return;
-	}
-
-	errno_t retval = async_data_read_finalize(name_chandle, linfo.name,
+		async_answer_0(&laddr, rc);
+		async_answer_0(&name, rc);
+		async_answer_0(call, rc);
+		return;
+	}
+
+	errno_t retval = async_data_read_finalize(&name, linfo.name,
 	    min(name_max_size, str_size(linfo.name)));
 	if (retval != EOK) {
 		free(linfo.name);
-		async_answer_0(laddr_chandle, retval);
-		async_answer_0(chandle, retval);
-		return;
-	}
-
-	retval = async_data_read_finalize(laddr_chandle, &linfo.mac_addr,
+		async_answer_0(&laddr, retval);
+		async_answer_0(call, retval);
+		return;
+	}
+
+	retval = async_data_read_finalize(&laddr, &linfo.mac_addr,
 	    min(laddr_max_size, sizeof(linfo.mac_addr)));
 
 	free(linfo.name);
 
-	async_answer_1(chandle, retval, linfo.def_mtu);
-}
-
-static void inetcfg_link_remove_srv(cap_call_handle_t chandle, ipc_call_t *call)
+	async_answer_1(call, retval, linfo.def_mtu);
+}
+
+static void inetcfg_link_remove_srv(ipc_call_t *call)
 {
 	sysarg_t link_id;
@@ -569,51 +569,50 @@
 
 	rc = inetcfg_link_remove(link_id);
-	async_answer_0(chandle, rc);
-}
-
-static void inetcfg_sroute_create_srv(cap_call_handle_t icall_handle,
-    ipc_call_t *icall)
+	async_answer_0(call, rc);
+}
+
+static void inetcfg_sroute_create_srv(ipc_call_t *icall)
 {
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "inetcfg_sroute_create_srv()");
 
-	cap_call_handle_t chandle;
+	ipc_call_t call;
 	size_t size;
-	if (!async_data_write_receive(&chandle, &size)) {
-		async_answer_0(chandle, EINVAL);
-		async_answer_0(icall_handle, EINVAL);
+	if (!async_data_write_receive(&call, &size)) {
+		async_answer_0(&call, EINVAL);
+		async_answer_0(icall, EINVAL);
 		return;
 	}
 
 	if (size != sizeof(inet_naddr_t)) {
-		async_answer_0(chandle, EINVAL);
-		async_answer_0(icall_handle, EINVAL);
+		async_answer_0(&call, EINVAL);
+		async_answer_0(icall, EINVAL);
 		return;
 	}
 
 	inet_naddr_t dest;
-	errno_t rc = async_data_write_finalize(chandle, &dest, size);
-	if (rc != EOK) {
-		async_answer_0(chandle, rc);
-		async_answer_0(icall_handle, rc);
-		return;
-	}
-
-	if (!async_data_write_receive(&chandle, &size)) {
-		async_answer_0(chandle, EINVAL);
-		async_answer_0(icall_handle, EINVAL);
+	errno_t rc = async_data_write_finalize(&call, &dest, size);
+	if (rc != EOK) {
+		async_answer_0(&call, rc);
+		async_answer_0(icall, rc);
+		return;
+	}
+
+	if (!async_data_write_receive(&call, &size)) {
+		async_answer_0(&call, EINVAL);
+		async_answer_0(icall, EINVAL);
 		return;
 	}
 
 	if (size != sizeof(inet_addr_t)) {
-		async_answer_0(chandle, EINVAL);
-		async_answer_0(icall_handle, EINVAL);
+		async_answer_0(&call, EINVAL);
+		async_answer_0(icall, EINVAL);
 		return;
 	}
 
 	inet_addr_t router;
-	rc = async_data_write_finalize(chandle, &router, size);
-	if (rc != EOK) {
-		async_answer_0(chandle, rc);
-		async_answer_0(icall_handle, rc);
+	rc = async_data_write_finalize(&call, &router, size);
+	if (rc != EOK) {
+		async_answer_0(&call, rc);
+		async_answer_0(icall, rc);
 		return;
 	}
@@ -623,5 +622,5 @@
 	    0, NULL);
 	if (rc != EOK) {
-		async_answer_0(icall_handle, rc);
+		async_answer_0(icall, rc);
 		return;
 	}
@@ -630,8 +629,8 @@
 	rc = inetcfg_sroute_create(name, &dest, &router, &sroute_id);
 	free(name);
-	async_answer_1(icall_handle, rc, sroute_id);
-}
-
-static void inetcfg_sroute_delete_srv(cap_call_handle_t chandle, ipc_call_t *call)
+	async_answer_1(icall, rc, sroute_id);
+}
+
+static void inetcfg_sroute_delete_srv(ipc_call_t *call)
 {
 	sysarg_t sroute_id;
@@ -643,8 +642,8 @@
 
 	rc = inetcfg_sroute_delete(sroute_id);
-	async_answer_0(chandle, rc);
-}
-
-static void inetcfg_sroute_get_srv(cap_call_handle_t icall_handle, ipc_call_t *icall)
+	async_answer_0(call, rc);
+}
+
+static void inetcfg_sroute_get_srv(ipc_call_t *icall)
 {
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "inetcfg_sroute_get_srv()");
@@ -660,62 +659,62 @@
 	errno_t rc = inetcfg_sroute_get(sroute_id, &srinfo);
 	if (rc != EOK) {
-		async_answer_0(icall_handle, rc);
-		return;
-	}
-
-	cap_call_handle_t chandle;
+		async_answer_0(icall, rc);
+		return;
+	}
+
+	ipc_call_t call;
 	size_t size;
-	if (!async_data_read_receive(&chandle, &size)) {
-		async_answer_0(chandle, EREFUSED);
-		async_answer_0(icall_handle, EREFUSED);
+	if (!async_data_read_receive(&call, &size)) {
+		async_answer_0(&call, EREFUSED);
+		async_answer_0(icall, EREFUSED);
 		return;
 	}
 
 	if (size != sizeof(inet_naddr_t)) {
-		async_answer_0(chandle, EINVAL);
-		async_answer_0(icall_handle, EINVAL);
-		return;
-	}
-
-	rc = async_data_read_finalize(chandle, &srinfo.dest, size);
-	if (rc != EOK) {
-		async_answer_0(chandle, rc);
-		async_answer_0(icall_handle, rc);
-		return;
-	}
-
-	if (!async_data_read_receive(&chandle, &size)) {
-		async_answer_0(chandle, EREFUSED);
-		async_answer_0(icall_handle, EREFUSED);
+		async_answer_0(&call, EINVAL);
+		async_answer_0(icall, EINVAL);
+		return;
+	}
+
+	rc = async_data_read_finalize(&call, &srinfo.dest, size);
+	if (rc != EOK) {
+		async_answer_0(&call, rc);
+		async_answer_0(icall, rc);
+		return;
+	}
+
+	if (!async_data_read_receive(&call, &size)) {
+		async_answer_0(&call, EREFUSED);
+		async_answer_0(icall, EREFUSED);
 		return;
 	}
 
 	if (size != sizeof(inet_addr_t)) {
-		async_answer_0(chandle, EINVAL);
-		async_answer_0(icall_handle, EINVAL);
-		return;
-	}
-
-	rc = async_data_read_finalize(chandle, &srinfo.router, size);
-	if (rc != EOK) {
-		async_answer_0(chandle, rc);
-		async_answer_0(icall_handle, rc);
-		return;
-	}
-
-	if (!async_data_read_receive(&chandle, &size)) {
-		async_answer_0(chandle, EREFUSED);
-		async_answer_0(icall_handle, EREFUSED);
-		return;
-	}
-
-	rc = async_data_read_finalize(chandle, srinfo.name,
+		async_answer_0(&call, EINVAL);
+		async_answer_0(icall, EINVAL);
+		return;
+	}
+
+	rc = async_data_read_finalize(&call, &srinfo.router, size);
+	if (rc != EOK) {
+		async_answer_0(&call, rc);
+		async_answer_0(icall, rc);
+		return;
+	}
+
+	if (!async_data_read_receive(&call, &size)) {
+		async_answer_0(&call, EREFUSED);
+		async_answer_0(icall, EREFUSED);
+		return;
+	}
+
+	rc = async_data_read_finalize(&call, srinfo.name,
 	    min(size, str_size(srinfo.name)));
 	free(srinfo.name);
 
-	async_answer_0(icall_handle, rc);
-}
-
-static void inetcfg_sroute_get_id_srv(cap_call_handle_t chandle, ipc_call_t *call)
+	async_answer_0(icall, rc);
+}
+
+static void inetcfg_sroute_get_id_srv(ipc_call_t *call)
 {
 	char *name;
@@ -728,5 +727,5 @@
 	    0, NULL);
 	if (rc != EOK) {
-		async_answer_0(chandle, rc);
+		async_answer_0(call, rc);
 		return;
 	}
@@ -735,17 +734,17 @@
 	rc = inetcfg_sroute_get_id(name, &sroute_id);
 	free(name);
-	async_answer_1(chandle, rc, sroute_id);
-}
-
-void inet_cfg_conn(cap_call_handle_t icall_handle, ipc_call_t *icall, void *arg)
+	async_answer_1(call, rc, sroute_id);
+}
+
+void inet_cfg_conn(ipc_call_t *icall, void *arg)
 {
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "inet_cfg_conn()");
 
 	/* Accept the connection */
-	async_answer_0(icall_handle, EOK);
+	async_answer_0(icall, EOK);
 
 	while (true) {
 		ipc_call_t call;
-		cap_call_handle_t chandle = async_get_call(&call);
+		async_get_call(&call);
 		sysarg_t method = IPC_GET_IMETHOD(call);
 
@@ -753,5 +752,5 @@
 		if (!method) {
 			/* The other side has hung up */
-			async_answer_0(chandle, EOK);
+			async_answer_0(&call, EOK);
 			return;
 		}
@@ -759,47 +758,47 @@
 		switch (method) {
 		case INETCFG_ADDR_CREATE_STATIC:
-			inetcfg_addr_create_static_srv(chandle, &call);
+			inetcfg_addr_create_static_srv(&call);
 			break;
 		case INETCFG_ADDR_DELETE:
-			inetcfg_addr_delete_srv(chandle, &call);
+			inetcfg_addr_delete_srv(&call);
 			break;
 		case INETCFG_ADDR_GET:
-			inetcfg_addr_get_srv(chandle, &call);
+			inetcfg_addr_get_srv(&call);
 			break;
 		case INETCFG_ADDR_GET_ID:
-			inetcfg_addr_get_id_srv(chandle, &call);
+			inetcfg_addr_get_id_srv(&call);
 			break;
 		case INETCFG_GET_ADDR_LIST:
-			inetcfg_get_addr_list_srv(chandle, &call);
+			inetcfg_get_addr_list_srv(&call);
 			break;
 		case INETCFG_GET_LINK_LIST:
-			inetcfg_get_link_list_srv(chandle, &call);
+			inetcfg_get_link_list_srv(&call);
 			break;
 		case INETCFG_GET_SROUTE_LIST:
-			inetcfg_get_sroute_list_srv(chandle, &call);
+			inetcfg_get_sroute_list_srv(&call);
 			break;
 		case INETCFG_LINK_ADD:
-			inetcfg_link_add_srv(chandle, &call);
+			inetcfg_link_add_srv(&call);
 			break;
 		case INETCFG_LINK_GET:
-			inetcfg_link_get_srv(chandle, &call);
+			inetcfg_link_get_srv(&call);
 			break;
 		case INETCFG_LINK_REMOVE:
-			inetcfg_link_remove_srv(chandle, &call);
+			inetcfg_link_remove_srv(&call);
 			break;
 		case INETCFG_SROUTE_CREATE:
-			inetcfg_sroute_create_srv(chandle, &call);
+			inetcfg_sroute_create_srv(&call);
 			break;
 		case INETCFG_SROUTE_DELETE:
-			inetcfg_sroute_delete_srv(chandle, &call);
+			inetcfg_sroute_delete_srv(&call);
 			break;
 		case INETCFG_SROUTE_GET:
-			inetcfg_sroute_get_srv(chandle, &call);
+			inetcfg_sroute_get_srv(&call);
 			break;
 		case INETCFG_SROUTE_GET_ID:
-			inetcfg_sroute_get_id_srv(chandle, &call);
+			inetcfg_sroute_get_id_srv(&call);
 			break;
 		default:
-			async_answer_0(chandle, EINVAL);
+			async_answer_0(&call, EINVAL);
 		}
 	}