Index: kernel/arch/ia64/include/arch/asm.h
===================================================================
--- kernel/arch/ia64/include/arch/asm.h	(revision a35b458e9db1ca95e679799dc7c1b12c83359ca3)
+++ kernel/arch/ia64/include/arch/asm.h	(revision 1433ecda9b732f3f185f902feb26826ec2496e03)
@@ -60,7 +60,7 @@
 
 	asm volatile (
-		"mf\n"
-		"mf.a\n"
-		::: "memory"
+	    "mf\n"
+	    "mf.a\n"
+	    ::: "memory"
 	);
 }
@@ -74,7 +74,7 @@
 
 	asm volatile (
-		"mf\n"
-		"mf.a\n"
-		::: "memory"
+	    "mf\n"
+	    "mf.a\n"
+	    ::: "memory"
 	);
 }
@@ -88,7 +88,7 @@
 
 	asm volatile (
-		"mf\n"
-		"mf.a\n"
-		::: "memory"
+	    "mf\n"
+	    "mf.a\n"
+	    ::: "memory"
 	);
 }
@@ -99,6 +99,6 @@
 
 	asm volatile (
-		"mf\n"
-		::: "memory"
+	    "mf\n"
+	    ::: "memory"
 	);
 
@@ -109,6 +109,6 @@
 
 	asm volatile (
-		"mf.a\n"
-		::: "memory"
+	    "mf.a\n"
+	    ::: "memory"
 	);
 
@@ -121,6 +121,6 @@
 
 	asm volatile (
-		"mf\n"
-		::: "memory"
+	    "mf\n"
+	    ::: "memory"
 	);
 
@@ -131,6 +131,6 @@
 
 	asm volatile (
-		"mf.a\n"
-		::: "memory"
+	    "mf.a\n"
+	    ::: "memory"
 	);
 
@@ -143,6 +143,6 @@
 
 	asm volatile (
-		"mf\n"
-		::: "memory"
+	    "mf\n"
+	    ::: "memory"
 	);
 
@@ -153,6 +153,6 @@
 
 	asm volatile (
-		"mf.a\n"
-		::: "memory"
+	    "mf.a\n"
+	    ::: "memory"
 	);
 
@@ -171,6 +171,6 @@
 
 	asm volatile (
-		"mov %[value] = r12"
-		: [value] "=r" (value)
+	    "mov %[value] = r12"
+	    : [value] "=r" (value)
 	);
 
@@ -188,6 +188,6 @@
 
 	asm volatile (
-		"mov %[value] = psr\n"
-		: [value] "=r" (v)
+	    "mov %[value] = psr\n"
+	    : [value] "=r" (v)
 	);
 
@@ -205,6 +205,6 @@
 
 	asm volatile (
-		"mov %[value] = cr.iva\n"
-		: [value] "=r" (v)
+	    "mov %[value] = cr.iva\n"
+	    : [value] "=r" (v)
 	);
 
@@ -220,6 +220,6 @@
 {
 	asm volatile (
-		"mov cr.iva = %[value]\n"
-		:: [value] "r" (v)
+	    "mov cr.iva = %[value]\n"
+	    :: [value] "r" (v)
 	);
 }
@@ -236,6 +236,6 @@
 
 	asm volatile (
-		"mov %[value] = cr.ivr\n"
-		: [value] "=r" (v)
+	    "mov %[value] = cr.ivr\n"
+	    : [value] "=r" (v)
 	);
 
@@ -248,6 +248,6 @@
 
 	asm volatile (
-		"mov %[value] = cr64\n"
-		: [value] "=r" (v)
+	    "mov %[value] = cr64\n"
+	    : [value] "=r" (v)
 	);
 
@@ -263,6 +263,6 @@
 {
 	asm volatile (
-		"mov ar.itc = %[value]\n"
-		:: [value] "r" (v)
+	    "mov ar.itc = %[value]\n"
+	    :: [value] "r" (v)
 	);
 }
@@ -278,6 +278,6 @@
 
 	asm volatile (
-		"mov %[value] = ar.itc\n"
-		: [value] "=r" (v)
+	    "mov %[value] = ar.itc\n"
+	    : [value] "=r" (v)
 	);
 
@@ -293,6 +293,6 @@
 {
 	asm volatile (
-		"mov cr.itm = %[value]\n"
-		:: [value] "r" (v)
+	    "mov cr.itm = %[value]\n"
+	    :: [value] "r" (v)
 	);
 }
@@ -308,6 +308,6 @@
 
 	asm volatile (
-		"mov %[value] = cr.itm\n"
-		: [value] "=r" (v)
+	    "mov %[value] = cr.itm\n"
+	    : [value] "=r" (v)
 	);
 
@@ -325,6 +325,6 @@
 
 	asm volatile (
-		"mov %[value] = cr.itv\n"
-		: [value] "=r" (v)
+	    "mov %[value] = cr.itv\n"
+	    : [value] "=r" (v)
 	);
 
@@ -340,6 +340,6 @@
 {
 	asm volatile (
-		"mov cr.itv = %[value]\n"
-		:: [value] "r" (v)
+	    "mov cr.itv = %[value]\n"
+	    :: [value] "r" (v)
 	);
 }
@@ -353,6 +353,6 @@
 {
 	asm volatile (
-		"mov cr.eoi = %[value]\n"
-		:: [value] "r" (v)
+	    "mov cr.eoi = %[value]\n"
+	    :: [value] "r" (v)
 	);
 }
@@ -368,6 +368,6 @@
 
 	asm volatile (
-		"mov %[value] = cr.tpr\n"
-		: [value] "=r" (v)
+	    "mov %[value] = cr.tpr\n"
+	    : [value] "=r" (v)
 	);
 
@@ -383,6 +383,6 @@
 {
 	asm volatile (
-		"mov cr.tpr = %[value]\n"
-		:: [value] "r" (v)
+	    "mov cr.tpr = %[value]\n"
+	    :: [value] "r" (v)
 	);
 }
@@ -401,8 +401,8 @@
 
 	asm volatile (
-		"mov %[value] = psr\n"
-		"rsm %[mask]\n"
-		: [value] "=r" (v)
-		: [mask] "i" (PSR_I_MASK)
+	    "mov %[value] = psr\n"
+	    "rsm %[mask]\n"
+	    : [value] "=r" (v)
+	    : [mask] "i" (PSR_I_MASK)
 	);
 
@@ -423,10 +423,10 @@
 
 	asm volatile (
-		"mov %[value] = psr\n"
-		"ssm %[mask]\n"
-		";;\n"
-		"srlz.d\n"
-		: [value] "=r" (v)
-		: [mask] "i" (PSR_I_MASK)
+	    "mov %[value] = psr\n"
+	    "ssm %[mask]\n"
+	    ";;\n"
+	    "srlz.d\n"
+	    : [value] "=r" (v)
+	    : [mask] "i" (PSR_I_MASK)
 	);
 
@@ -473,8 +473,8 @@
 {
 	asm volatile (
-		"rsm %[mask]\n"
-		";;\n"
-		"srlz.d\n"
-		:: [mask] "i" (PSR_PK_MASK)
+	    "rsm %[mask]\n"
+	    ";;\n"
+	    "srlz.d\n"
+	    :: [mask] "i" (PSR_PK_MASK)
 	);
 }